<!-- 
    @author Caesarovich
    @repository https://github.com/Caesarovich/rome-webshell

    This code is for educationnal purposes only.
    Malicious usage of this code will not hold the author responsible.
    Do not pentest without explicit permissions.

-->





<?php

class Tools_Text {
	public static function htmlEscape ($str) {
		return htmlspecialchars ($str,ENT_QUOTES,'UTF-8');
	}
	
	public static function searchString ($str) {
		return trim(str_replace(array('%','_'),'',$str));
	}
	
	public static function htmlToBBCode ($text) {
		return str_ireplace (array('<strong>','</strong>','<em>','</em>','<u>','</u>','<blockquote>','</blockquote>'),array('[b]','[/b]','[i]','[/i]','[u]','[/u]','[quote]','[/quote]'),$text);
	}
	
	public static function getBBCode ($str) {
		$bbsearch = array (
			'/(\[b\])([\s\S]+)(\[\/b\])/Ui',
			'/(\[i\])([\s\S]+)(\[\/i\])/Ui',
			'/(\[u\])([\s\S]+)(\[\/u\])/Ui',
			'/(\[url=)(.+)(\])([\s\S]+)(\[\/url\])/Ui',
			'/(\s|^)(www\.[a-z0-9\-.]+\.[a-z]{2,4})(\s|$)/Ui',
			'/(\s|^)((http:\/\/|https:\/\/|ftp:\/\/|ftps:\/\/)[^\s]+)(\s|$)/i',
			'/(\[quote\])([\s\S]+)(\[\/quote\])/Ui'
		);
		
		$bbreplace = array (
			'<strong>\2</strong>',
			'<em>\2</em>',
			'<u>\2</u>',
			'<a href="\2" target="_blank">\4</a>',
			' <a href="http://\2/" target="_blank">\2</a> ',
			' <a href="\2" target="_blank">\2</a> ',
			'<blockquote>\2</blockquote>'
		);
		return preg_replace($bbsearch, $bbreplace, $str);
	}
	
	public static function formatText ($newtext,$wrap=true,$wraplength=40) {
		$newtext = $newtext;
		if ($wrap) {
			$newtext = nl2br($newtext);
			$split = explode(' ',$newtext);
			$result = '';
			$search=array();
			$replace=array();
	
			foreach ($split as $word) {            
				if (strstr ($word,'href')) {            
					$word=str_replace('\'','"',$word);
					$tmp=explode('"',$word);        
					$link=parse_url($tmp[1]);        
					$search[] = '>'.$tmp[1].'<';
					$replace[] = '>'.$link['scheme'].'://'.$link['host'].'/<';
				}
				
				elseif (!strstr($word,'http')) {
					if (mb_strlen($word) >= $wraplength) {
						//$word=utf8WordWrap ($word,$wraplength,' ',true);
					}
				}
				$result .= $word.' ';
			}
			$newtext = str_replace ($search,$replace,$result);
		} else $newtext = nl2br($newtext);
		return $newtext;
	}
	
	public static function utf8StrReplace($s,$r,$str){
		if (!is_array($s)) {
			$s = '!'.preg_quote($s,'!').'!u';
		} else {
			foreach ($s as $k => $v) {
				$s[$k] = '!'.preg_quote($v).'!u';
			}
		}
		return preg_replace($s,$r,$str);
	}
	
	public static function utf8WordWrap($str, $width, $break=' '){
		return preg_replace("/(([^ ]){".$width.",})/Uu","$1".$break,$str);
	}
	
	public static function asciiToUtf8 ($str) {
		return preg_replace ('/([\x80-\xff])/se', "pack (\"C*\", (ord ($1) >> 6) | 0xc0, (ord ($1) & 0x3f) | 0x80)", $str);
	}
	
	public static function cleanString($wild) {
	
		//$old = $wild;
		//echo $old.'<br>';
	
		//	$wild = 'e14_8609';

		if($wild) {
		
		$wild = trim($wild);
		$wild = self :: translitString($wild);
		$wild = str_replace (array("-","=","!",'/','.',','),"",$wild);	
		$wild = str_replace (array(" ","\n","\t"),'-',$wild);	
		$wild = preg_replace("/[^A-Za-z0-9\-]/","",$wild);
		$wild = str_replace ("---","-",$wild);
		$wild = str_replace ("--","-",$wild); 

		  //echo $wild.'<br>';
		}
		
		return $wild; 
	}
	
	public static function mbUcfirst($str, $e='utf-8') {
		if (function_exists('mb_strtoupper')) {
			$fc = mb_strtoupper(mb_substr($str, 0, 1, $e), $e);
			return $fc.mb_substr($str, 1, mb_strlen($str, $e), $e);
		}
		else {
			$str = utf8_decode($str);
			$str[0] = strtr($str[0],
				"abcdefghýijklmnopqrstuvwxyz".
				"\x9C\x9A\xE0\xE1\xE2\xE3".
				"\xE4\xE5\xE6\xE7\xE8\xE9".
				"\xEA\xEB\xEC\xED\xEE\xEF".
				"\xF0\xF1\xF2\xF3\xF4\xF5".
				"\xF6\xF8\xF9\xFA\xFB\xFC".
				"\xFE\xFF",
				"ABCDEFGHÝIJKLMNOPQRSTUVWXYZ".
				"\x8C\x8A\xC0\xC1\xC2\xC3\xC4".
				"\xC5\xC6\xC7\xC8\xC9\xCA\xCB".
				"\xCC\xCD\xCE\xCF\xD0\xD1\xD2".
				"\xD3\xD4\xD5\xD6\xD8\xD9\xDA".
				"\xDB\xDC\xDE\x9F");
			return utf8_encode($str);
		}
	}
	
	public static function highlightTerms($text_string,$keywords) {
		if (!is_array($keywords)) {
			$keywords = explode(" ",$keywords);
		}
	
		for ($x=0;$x<count($keywords);$x++) {
			if (strlen($keywords[$x]) > 1) {
				preg_match_all ("'" . $keywords[$x] . "'si", $text_string, $items);
				for ($y=0;$y<count($items);$y++) {
					if (isset($items[$y][0])) {
	
						$text_string = str_replace($items[$y][0],'<span class="textHighlight">' . $items[$y][0] . '</span>',$text_string);
					}
				}   
			}
		}
		return $text_string;
	}
	
	public static function trimText ($text,$length=64,$tail="...") {
	   $text = trim($text);
	   $txtl = mb_strlen($text);
	   if($txtl > $length) {
		   for($i=1;$text[$length-$i]!=" ";$i++) {
			   if($i == $length) {
				   return mb_substr($text,0,$length) . $tail;
			   }
		   }
		   $text = mb_substr($text,0,$length-$i+1) . $tail;
	   }
	   return $text;
	}
	
	public static function translitString($str) {
	 $str = str_replace(array('Ā','Č','Ē','Ģ','Ī','Ķ','Ļ','Ņ','Š','Ū','Ž', 'ā','č','ē','ģ','ī','ķ','ļ','ņ','š','ū','ž','й','ц','у','к','е','н','г','ш','щ','з','х','ъ','ф','ы','в','а','п','р','о','л','д','ж','э','я','ч','с','м','и','т','ь','б','ю','Й','Ц','У','К','Е','Н','Г','Ш','Щ','З','Х','Ъ','Ф','Ы','В','А','П','Р','О','Л','Д','Ж','Э','Я','Ч','С','М','И','Т','Ь','Б','Ю'), array('A','C','E','G','I','K','L','N','S','U','Z','a','c','e','g','i','k','l','n','s','u','z','i','c','u','k','e','n','g','sh','sh','z','h','i','f','i','v','a','p','r','o','l','d','zh','e','ja','ch','s','m','i','t','','b','ju','I','C','U','K','E','N','G','SH','SH','Z','H','I','F','I','V','A','P','R','O','L','D','ZH','E','JA','CH','S','M','I','T','','B','JU'),$str);
	 return $str;
	}

	public static function getRandomLetters($num) { //генерируем соль для md5
	    $letter='';
    	$characters = array("A","B","C","D","E","F","G","H","J","K","L","M","N","P","R","S","T","U","V","Z");
		$amount=count($characters);
		for ($i=1;$i<=$num;$i++) {
    		$n=rand(0,($amount-1));
			$letter .=$characters[$n];
		}
		return $letter;
	}
	
	public static function getRandomHash ($length=32) {
		return substr(md5(uniqid().date("dmYHis")),0, $length);
	}
	
	public static function getRandomNumber ($length=6) {
		$chars = '1234567890';
		// Length of character list
		$chars_length = (strlen($chars) - 1);

		// Start our string
		$string = $chars[rand(0, $chars_length)];

		// Generate random string
		for ($i = 1; $i < $length; $i = strlen($string))
		{
		// Grab a random character from our list
		$r = $chars[rand(0, $chars_length)];

		// Make sure the same two characters don't appear next to each other
		if ($r != $string[$i - 1]) $string .=  $r;
		}

		// Return the string
		return $string;
	}
}
